# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class GroupMember(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'display_name': 'str',
        'member_type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'displayName',
        'member_type': 'memberType'
    }

    def __init__(self, id=None, display_name=None, member_type=None, _configuration=None):  # noqa: E501
        """GroupMember - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._display_name = None
        self._member_type = None
        self.discriminator = None

        self.id = id
        self.display_name = display_name
        self.member_type = member_type

    @property
    def id(self):
        """Gets the id of this GroupMember.  # noqa: E501


        :return: The id of this GroupMember.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GroupMember.


        :param id: The id of this GroupMember.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this GroupMember.  # noqa: E501


        :return: The display_name of this GroupMember.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this GroupMember.


        :param display_name: The display_name of this GroupMember.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def member_type(self):
        """Gets the member_type of this GroupMember.  # noqa: E501


        :return: The member_type of this GroupMember.  # noqa: E501
        :rtype: str
        """
        return self._member_type

    @member_type.setter
    def member_type(self, member_type):
        """Sets the member_type of this GroupMember.


        :param member_type: The member_type of this GroupMember.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and member_type is None:
            raise ValueError("Invalid value for `member_type`, must not be `None`")  # noqa: E501
        allowed_values = ["GROUP", "PERSON"]  # noqa: E501
        if (self._configuration.client_side_validation and
                member_type not in allowed_values):
            raise ValueError(
                "Invalid value for `member_type` ({0}), must be one of {1}"  # noqa: E501
                .format(member_type, allowed_values)
            )

        self._member_type = member_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GroupMember, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GroupMember):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GroupMember):
            return True

        return self.to_dict() != other.to_dict()
